设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 765|回复: 11

[每日一码] Using acedSSSetKwordCallbackPtr on selections

[复制链接]

已领礼包: 13个

财富等级: 恭喜发财

发表于 2016-9-12 09:05:00 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x


This method allow a custom code to be executed when the user selects a keyword, which allow us include some additional keywords.

On the sample below, when acedSSGet() is called in a custom command, the user is able to use two new keywords: LInes to select all lines in the current drawing and CIRcles to select all circles. The callback function uses all possible return values.

First, check below the custom command, that register for the call back.


游客,如果您要查看本帖隐藏内容请回复至少1次,目前您回复了0次!


Now the callback that is executed when the keyword is selected:

  1. // Callback function for acedSSGet()
  2. resbuf* ssCallback(const TCHAR* kword)
  3. {
  4.   // kword contains the global keyword
  5.   acutPrintf(_T("\nCallback: '%s'"), kword);

  6.   // result to return
  7.   // NULL: no changes on selection set
  8.   resbuf *result = NULL;

  9.   if (!wcscmp(kword, _T("LInes"))) {
  10.     // select all lines (just for testing)
  11.     AcDbObjectIdArray objIds;
  12.     getLines(objIds);
  13.     // create resbuf containing single
  14.     // enames from object id array
  15.     result = getResbuf(objIds);
  16.   } else if (!wcscmp(kword, _T("CIRcles"))) {
  17.     // select all circles (just for testing)
  18.     AcDbObjectIdArray objIds;
  19.     getCircles(objIds);
  20.     // create resbuf containing a selection set
  21.     ads_name ss;
  22.     acedSSGet(_T("X"), NULL, NULL,
  23.       acutBuildList(RTDXF0, _T("CIRCLE"), RTNONE),
  24.       ss);
  25.     result = acutBuildList(RTPICKS, ss, RTNONE);
  26.   } else {
  27.     // return an error message
  28.     result = acutBuildList(RTSTR, _T("\nUnknown error"), RTNONE);
  29.   }
  30.   return result;
  31. }


And finally some additional methods for this specific sample:

  1. resbuf* getResbuf(AcDbObjectIdArray ids)
  2. {
  3.   resbuf *result = NULL, *temp1, *temp2;
  4.   ads_name ename;
  5.   int length = ids.length();

  6.   for (int i = 0; i < length; ++i) {
  7.     acdbGetAdsName(ename, ids);
  8.     temp2 = acutBuildList(RTENAME, ename, RTNONE);
  9.     if (result == NULL) {
  10.       result = temp2;
  11.     } else {
  12.       temp1->rbnext = temp2;
  13.     }
  14.     temp1 = temp2;
  15.   }

  16.   return result;
  17. }

  18. void getLines(AcDbObjectIdArray& ids)
  19. {
  20.   // select all lines from model space
  21.   // (without any error checking)
  22.   AcDbBlockTable *pTable;
  23.   AcDbBlockTableRecord *pModelSpace;
  24.   AcDbBlockTableRecordIterator *pIter;
  25.   AcDbEntity* pEnt;

  26.   acdbHostApplicationServices()->workingDatabase()->
  27.     getBlockTable(pTable, AcDb::kForRead);
  28.   pTable->getAt(ACDB_MODEL_SPACE, pModelSpace, AcDb::kForRead);
  29.   pTable->close();
  30.   pModelSpace->newIterator(pIter);
  31.   pModelSpace->close();

  32.   for (; !pIter->done(); pIter->step()) {
  33.     pIter->getEntity(pEnt, AcDb::kForRead);
  34.     if (pEnt->isKindOf(AcDbLine::desc()))
  35.       ids.append(pEnt->objectId());
  36.     pEnt->close();
  37.   }

  38.   delete pIter;
  39. }

  40. void getCircles(AcDbObjectIdArray& ids)
  41. {
  42.   // select all circles from model space
  43.   // (without any error checking)
  44.   AcDbBlockTable *pTable;
  45.   AcDbBlockTableRecord *pModelSpace;
  46.   AcDbBlockTableRecordIterator *pIter;
  47.   AcDbEntity* pEnt;

  48.   acdbHostApplicationServices()->workingDatabase()->
  49.     getBlockTable(pTable, AcDb::kForRead);
  50.   pTable->getAt(ACDB_MODEL_SPACE, pModelSpace, AcDb::kForRead);
  51.   pTable->close();
  52.   pModelSpace->newIterator(pIter);
  53.   pModelSpace->close();

  54.   for (; !pIter->done(); pIter->step()) {
  55.     pIter->getEntity(pEnt, AcDb::kForRead);
  56.     if (pEnt->isKindOf(AcDbCircle::desc()))
  57.       ids.append(pEnt->objectId());
  58.     pEnt->close();
  59.   }

  60.   delete pIter;
  61. }


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 2266个

财富等级: 金玉满堂

发表于 2016-9-12 15:48:10 | 显示全部楼层
学习!!!!!!!!!!!!!!!!!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 1个

财富等级: 恭喜发财

发表于 2016-9-21 17:31:47 | 显示全部楼层
我也来学习学习,提高水平
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 474个

财富等级: 日进斗金

发表于 2016-9-26 15:53:08 | 显示全部楼层
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

发表于 2016-10-10 10:17:05 | 显示全部楼层
学习ing..........................
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

点击这里给我发消息

发表于 2017-6-28 12:08:12 | 显示全部楼层
1111111111111111111111111
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 112个

财富等级: 日进斗金

发表于 2019-7-12 16:42:36 | 显示全部楼层
error C3867: 'CArxProject1App::keywordCallback': function call missing argument list; use '&CArxProject1App::keywordCallback' to create a pointer to member
请点击此处下载

查看状态:需购买或无权限

您的用户组是:游客

文件名称:ArxProject1.rar 
下载次数:3  文件大小:14.08 KB 
下载权限: 不限 以上  [免费赚D豆]


附件为acedSSGet使用K参数的例子,但编译不过,请问如何处理?
参考自:http://blog.sina.com.cn/s/blog_5f63dcd10102ww8i.html
https://blog.csdn.net/panzhijiep ... le/details/40824173
http://www.cadgj.com/?p=170
http://www.cadgj.com/?p=1448
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 913个

财富等级: 财运亨通

发表于 2020-4-1 17:50:06 | 显示全部楼层
有没完整的编译版
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

点击这里给我发消息

已领礼包: 2959个

财富等级: 家财万贯

发表于 2020-4-2 11:11:54 | 显示全部楼层
学习中谢谢分享
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2020-4-5 11:03:17 | 显示全部楼层

1111111111111111111111111
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2020-4-23 06:13:20 | 显示全部楼层
谢谢楼主分享!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 10个

财富等级: 恭喜发财

发表于 2020-9-24 22:19:07 | 显示全部楼层
thank you sharing
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-10-21 15:16 , Processed in 0.186594 second(s), 78 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表